/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#include  <stdio.h>
#include  "win_dlg.h"


//----------------------------
//  GetFileName
//----------------------------
//  return value:
//   -1 ... cancel or error
//   otherwise ... filter no
//----------------------------
int
GetFileName(HWND hWnd, char* szFileName, const char* szFilter, const char* szTitle, bool bSave)
{
	OPENFILENAME	ofn;
	char ext[4];

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.hwndOwner	= hWnd;
	ofn.Flags		= OFN_EXPLORER | OFN_HIDEREADONLY;
	ofn.lpstrFilter	= szFilter;
	ofn.lpstrFile	= szFileName;
	ofn.lpstrTitle	= szTitle;
	ofn.nMaxFile	= 256;
	ext[0] = '\0';
	ofn.lpstrDefExt = ext;	// 邱ƂŁAgqtB^玩Iɕ₤
	
	BOOL res;
	if (bSave) {
		ofn.Flags |= OFN_OVERWRITEPROMPT;			//  check overwrite
		res = GetSaveFileName(&ofn);
	} else {
		ofn.Flags |= OFN_FILEMUSTEXIST;				//  the file must exist
		res = GetOpenFileName(&ofn);
	}
	if (res != TRUE)  return -1;
	return  ofn.nFilterIndex;	// return current filter index
}


//========================
//  formatted MessageBox
//========================
int
MessageBoxf(HWND hWnd, LPCTSTR szCaption, UINT uType, LPCSTR szFormat, ...)
{
	char	szBuffer[256];
	va_list	pArgs;
	va_start( pArgs, szFormat );
		vsprintf( szBuffer, szFormat, pArgs );
	va_end( pArgs );
	return  MessageBox(hWnd, szBuffer, szCaption, uType);
}


//-------------------------------------------
//  TextOutf: output a formatted text on DC
//-------------------------------------------
int
TextOutf(HDC hDC, int x, int y, const char* szFormat, ...)
{
	int				length;
	static char		szBuffer[1024];
	va_list			pArgs;
	va_start( pArgs, szFormat );
		length = vsprintf( szBuffer, szFormat, pArgs );
	va_end( pArgs );
	if ( !TextOut(hDC, x,y, szBuffer, length) )
		return 0;

	return length;
}
